unit dat_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    StatusBar1: TStatusBar;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    GroupBox1: TGroupBox;
    PPM_catalogue: TEdit;
    SAO_catalogue: TEdit;
    Label_epoch: TLabel;
    Label1: TLabel;
    magedit: TEdit;
    UpDown1: TUpDown;
    epoch1: TEdit;
    SAOcat: TRadioButton;
    ppmcat: TRadioButton;
    powerdown_enabled: TCheckBox;
    Label4: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

type
  hnskyhdr = record
             nr1 : byte;
             nr2 : byte;
             nr3 : byte;
             ra7 : byte;
             ra8 : byte;
             ra9 : byte;
             dec7: byte;
             dec8: byte;    {note with word and smallint, delphi makes longer records !!!}
             dec9: shortint;
             mag0: shortint;
             spec2: byte;


   end;
var
  tof    : file;
var
  step, step2, maximum,mag_begin          :  real;
  bufferstring1                           : Tstrings;
  file_counter,nr_of_errors,nr_of_stars,nr_of_skipped,
  Numwritten                                          : integer;
  epoch2:real;
  ra1,dec1:real;
  mag1    :integer;
  spectral:string;
  readposition : integer;

implementation
{$R *.dfm}
uses unit_sao, unit_PPM;

function  limit_radialen(z:real):real;
begin
  while z<0 do z:=z+2*pi;
  while z>2*pi do z:=z-2*pi;
  limit_radialen:=z;
end;
function remove_spaces(s:string):string;
var i:integer;
    s2:string;
begin
  s2:='';
  for i:=1 to length(s) do if s[i]<>' ' then s2:=s2+s[i];
  remove_spaces:=s2;
end;
function ShutMeDown:string;
var
  hToken : THandle;
  tkp,p : TTokenPrivileges;
  RetLen : DWord;
  ExReply: LongBool;
  Reply : DWord;
begin
  if OpenProcessToken(GetCurrentProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,hToken) then
  begin
    if LookupPrivilegeValue(nil,'SeShutdownPrivilege',tkp .Privileges[0].Luid) then
    begin
      tkp.PrivilegeCount := 1;
      tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      AdjustTokenPrivileges(hToken,False,tkp,SizeOf(TTokenPrivileges),p,RetLen);
      Reply := GetLastError;
      if Reply = ERROR_SUCCESS then
      begin
        ExReply:= ExitWindowsEx(EWX_POWEROFF or EWX_FORCE, 0);
        if ExReply then Result:='Shutdown Initiated'
        else
        Result:='Shutdown failed with ' + IntToStr(GetLastError);
      end;
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  bufferstring1 := Tstringlist.Create;
end;
procedure TForm1.FormDestroy(Sender: TObject);
begin
  bufferstring1.free;{free suppl1}
end;
function floattostr_one_digit(r:real):string;
begin
    str(r:0:1,result);
end;

PROCEDURE sortSTARS(magn_start,step: real); {read file and find stars between magn_start and magn_start+step}
var nr_of_errors                : longint;
    rastart,decstart,nr_star    : integer;

    buf2: array[1..12] of byte;
    p2           : ^hnskyhdr;		        { pointer to hnskyrecord }
    file_opened,to_open : string;
    spec1                       : integer;

BEGIN
  file_opened:=''; {indicates of file is open}
  repeat
    if readposition>=bufferstring1.count then {buffer processed}
    begin
      if file_opened<>'' then close(Tof);{close file already open}
      if (getasynckeystate(vk_F4))<0  then halt;
      exit;
    end;
    if (form1.saocat.checked) then read_SAO(epoch2,ra1,dec1,mag1,nr_star,Spec1)
    else read_PPM(epoch2,ra1,dec1,mag1,nr_star,Spec1);
    if mag1<999 then  {999 check if last record is within}
    begin
      p2:= @buf2[1];			{ set pointer }
      with p2^ do
      begin
        {make 3 byte word:}
        nr1 := lo(nr_star);{ important nr must be longint}
        nr2 := hi(nr_star);
        nr3 := nr_star shr 16;{=trunc(nr/(256*256))}

       {Right accension===========================================}
        rastart := round(((256*256*256)-1)*(limit_radialen(ra1))/(2*pi));
        {make 3 byte word:}
        ra7 := lo(rastart);
        ra8 := hi(rastart);
        ra9 := rastart shr 16;{make 3 byte word};

        {declination===========================================}

        decstart :=round(( ((256*256*128)-1)*(dec1)/(0.5*pi)));

        {make 3 byte integer:}
        dec7 := lo(decstart);
        dec8 := hi(decstart);
        dec9 := decstart shr 16 ;{make 3 byte integer, important decstart must be longint};

       {magnitude===========================================}

        if (((mag1/10)>25.4-2) or ((mag1/10)<-2.0)) then  inc(nr_of_errors)
        else
        begin
          mag0:= mag1;
                         {new magnitude 12.7 ==>  12.7}
                         {              12.8 ==> -12.8}
                         {              12.9 ==> -12.7}
                         {              13.0 ==> -12.6}
                         {              ..............}
                         {              23.4 ==> - 2.0 do not go further, confusion with Sirius=-1.7}




        {spectrum===========================================}
         spec2:=spec1;

         {====write to DAT  files====}
         if (form1.saocat.checked) then to_open:='sao_hsky.dat' else to_open:='ppm_hsky.dat'; 
         if file_opened<>to_open then {dump file not open yet}
         begin {other dump file required,  close and open other section}
           assignfile(tof,to_open);{assign correct D32 file}
           filemode:=2;{read/write}
           reset(tof,1);
           seek(tof,filesize(tof));
           file_opened:=to_open;{remember file openened}
         end;
         blockwrite(tof,buf2, SizeOf(hnskyhdr),Numwritten);
         inc(nr_of_stars);

         {====write to D32  files end====}
       end;

     end;
   end; {good star}
   until false;
END;


procedure TForm1.Button1Click(Sender: TObject);
var
  error2 : integer;
  info1  : array[0..112] of char;
begin
  nr_of_stars:=0;
  nr_of_skipped:=0;
  if radiobutton1.Checked then step2:=0.1
  else
  if radiobutton2.Checked then step2:=1
  else
  if radiobutton3.Checked then step2:=3
  else
  if radiobutton4.Checked then step2:=25;{no magnitude sorting dump all stars as found in D32 files}


  val(epoch1.text,epoch2,error2);
  if error2<>0 then
  begin
    epoch1.color:=clred;
    exit;
  end
  else
  epoch1.color:=clwindow;


  maximum:=updown1.position/10;


  {make header begin===========================================================}

  if (saocat.checked) then strpcopy(info1,copy('SAO catalogue, equinox J2000, epoch='+epoch1.text+', 257474 stars, For HNSKY 2015-6-3, (catalogue 1131A)                                                                                                                                                                                        ',1,112));{do not  override  length of info1, otherwise error at the end of program}
  if (ppmcat.checked) then strpcopy(info1,copy('PPM catalogue, equinox J2000, epoch='+epoch1.text+', 468861 stars, For HNSKY 2015-6-3, (catalogues 1146,1193,1206,1208)                                                                                                                                                                         ',1,112));{do not  override  length of info1, otherwise error at the end of program}

  assignfile(tof,'sao_hsky.dat');
  if (ppmcat.checked) then assignfile(tof,'ppm_hsky.dat');

 {make header ===========================================================}

  filemode:=2;{read/write}
  rewrite(tof,1);
  Blockwrite(tof,info1,1+ 10*SizeOf(hnskyhdr),Numwritten);{header is 111 bytes for historical reasons}
  closefile(tof);
  if numwritten<111 then
    begin
      messagebox(form1.handle,pchar('ERROR !!! Can"t create file files. Close HNSKY'),pchar('Error'),MB_ICONERROR);
      exit;
    end;
 {make header end===========================================================}

  {sort file}
  mag_begin:=-2;{start magnitude}
  if (saocat.checked) then loadbuffer(sao_catalogue.text) {load tycho file in Tstrings}
  else loadbuffer(ppm_catalogue.text); {load tycho file in Tstrings}

  repeat
    if ((mag_begin<1)  and (step2<3)) then step:=3 {speedup first part} else step:=step2;{make bigger steps before magnitude 1}
    if mag_begin+step>maximum then step:=maximum-mag_begin;{adjust step before last go.}

    readposition:=44;{skip text}
    if (ppmcat.checked) then  readposition:=44;{skip text}

    file_counter:=0;
    sortSTARS(mag_begin,step); {read buffer and find stars between magn_start and magn_start+step}
    statusbar1.SimpleText:=('Now doing magnitude: '+floattostr_one_digit(mag_begin)+' to '+floattostr_one_digit(mag_begin+step)+'    Stars done: '+ inttostr(nr_of_stars));
    form1.caption:=('Now doing magnitude: '+floattostr_one_digit(mag_begin)+' to '+floattostr_one_digit(mag_begin+step)+'    Stars done: '+ inttostr(nr_of_stars));
    mag_begin:=mag_begin+step;
  until mag_begin>=maximum;
  if ((powerdown_enabled.checked)and (nr_of_stars>100)) then statusbar1.simpletext:=ShutMeDown
  else
  messagebox(form1.handle,pchar('Ready.   Stars done:'+ inttostr(nr_of_stars)),pchar('Ready'),MB_ICONINFORMATION);

end;

end.
